/////////////////////////////////////////////////////////////////////////////
//           WWWW       WWW                                      
//            WW         W                                       
//            WW         W                                       
//            WW         W                                       
//            WW    W    W     WWWWWW    WWWW    WWW     WWWWW   
//            WW   WWW   W    WW    WW    WW      W    WW    WWW 
//            WW  W  WW  W          WW    WW      W   WW     WW  
//            WW W    WW W    WWWWWWWW     WW    W    WW   WW    
//            WWW      WWW   WW     WW      WW  W     WWWWW      
//            WW        WW   WW    WWW       WWW       WW     WW 
//            W          W    WWWWW WWW       W          WWWWW   
//                                                    
//                                                    
//                                                    
//       WW        WW                                      
//       WWW      WWW                  W                   
//       W WW    W WW                 WW     WW            
//       W  WW  W  WW                 WW                   
//       W   WWW   WW      WWWW     WWWWWW   WW      WWWW     WWW WWWWW   
//       W    W    WW    WW    WW     WW    WWW    WW    WW    WWW    WW  
//       W         WW   WW      WW    WW     WW   WW      WW   WW     WW  
//       W         WW   WW      WW    WW     WW   WW      WW   WW     WW  
//       W         WW   WW      WW    WW     WW   WW      WW   WW     WW  
//       W         WW    WW    WW     WW     WW    WW    WW    WW     WW  
//      WWW       WWWW     WWWW        WWW  WWWW     WWWW     WWWW   WWWW 
//                                                                          
//                                                                          
//                                                                         
//   WWWWW                                 WWW                               
// WW     WW                                WW              W                 
//WW       W   WW                           WW             WW                 
//WW                                        WW             WW                 
// WWW         WW  WWW WW  WW   WWW   WWW   WW    WWWWW  WWWWWW   WWW    WWW WWW
//   WWWWWW   WWW   WWW WWW WW   WW    WW   WW   WW   WW   WW   WW   WW   WWW   
//       WWW   WW   WW  WW  WW   WW    WW   WW        WW   WW  WW     WW  WW    
//         WW  WW   WW  WW  WW   WW    WW   WW   WWWWWWW   WW  WW     WW  WW    
//W        WW  WW   WW  WW  WW   WW    WW   WW  WW    WW   WW  WW     WW  WW    
//WW      WW   WW   WW  WW  WW   WW   WWW   WW  WW   WWW   WW   WW   WW   WW    
//  WWWWWW    WWWW WWWW WW WWWW   WWWW WWW WWWW  WWWW WWW   WWW   WWW    WWWW   
//                                                                        
//                                                                        
 
 
 

////////////////////////////////////////////////////////////
//
// waveSimulator.cxx 
// Display a surface mesh with waves produced by an oscillator.
// Version 1.00
//
// Copyright (c) 2002   David C. Banks  
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public Licence
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// banks@cs.fsu.edu
//
// Dr. David C. Banks
// Department of Computer Science
// Florida State University
// 488 Dirac Science Library 
// Tallahassee, FL 32306
//

/////////////////////////////////////////////////////////////////////////////
//                                                                            
// WWWWW                                                                      
// WW  WW                              WW          WW   WW                    
// WW  WW                                          WW                         
// WW  WW   WWW    WWWW   WWW   WW WW  WW  WWWW   WWWW  WW   WWW   WWWW       
// WW  WW  WW WW  WW     WW WW  WWW    WW  WW WW   WW   WW  WW WW  WW WW      
// WW  WW  WWWWW   WWW   WW     WW     WW  WW WW   WW   WW  WW WW  WW WW      
// WW  WW  WW        WW  WW WW  WW     WW  WW WW   WW   WW  WW WW  WW WW      
// WWWWW    WWWW  WWWW    WWW   WW     WW  WWWW    WW   WW   WWW   WW WW      
//                                         WW                                 
//                                         WW                                 


////////////////////////////////////////////////////////////
//
// Description
//
// This program simulates waves moving on a surface.
//

/////////////////////////////////////////////////////////////////////////////
//                                                                           
// WWWW                WWW             WW                                    
//  WW                  WW             WW                                    
//  WW                  WW             WW                                    
//  WW   WWWW    WWW    WW   WW WW   WWWW   WWW    WWWW                      
//  WW   WW WW  WW WW   WW   WW WW  WW WW  WW WW  WW                         
//  WW   WW WW  WW      WW   WW WW  WW WW  WWWWW   WWW                       
//  WW   WW WW  WW WW   WW   WW WW  WW WW  WW        WW                      
// WWWW  WW WW   WWW   WWWW   WWWW   WWWW   WWWW  WWWW                       
//                                                                           
// Includes

#include <stdio.h>
#include <stdlib.h>


#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>

#include <Inventor/nodes/SoSeparator.h>

#include "grid.h"



/////////////////////////////////////////////////////////////////////////////
//                                                                            
//  WWWWW  WWW          WW             WWW                                    
// WW  WW   WW          WW              WW                                    
// WW       WW          WW              WW                                    
// WW WWW   WW    WWW   WWWW    WWWW    WW    WWWW                            
// WW  WW   WW   WW WW  WW WW      WW   WW   WW                               
// WW  WW   WW   WW WW  WW WW   WWWWW   WW    WWW                             
// WW  WW   WW   WW WW  WW WW  WW  WW   WW      WW                            
//  WWWWW  WWWW   WWW   WWWW    WWWWW  WWWW  WWWW                             
//                                                                            
// Globals



// Global Variables

        GridStruct       Grid;


// Function declarations



SoSeparator *
createScene();

void
updateMesh();

SoXtExaminerViewer *
createAndLayoutMainWindow(int argc, char **argv);




/////////////////////////////////////////////////////////////////////////////
//                                                                            
// WWWW                               WWW                                     
//  WW          WW   WW   WW           WW   WW                                
//  WW               WW                WW                                     
//  WW   WWWW   WW  WWWW  WW   WWWW    WW   WW  WWWWW   WWW                   
//  WW   WW WW  WW   WW   WW      WW   WW   WW    WW   WW WW                  
//  WW   WW WW  WW   WW   WW   WWWWW   WW   WW   WW    WWWWW                  
//  WW   WW WW  WW   WW   WW  WW  WW   WW   WW  WW     WW                     
// WWWW  WW WW  WW   WW   WW   WWWWW  WWWW  WW  WWWWW   WWWW                  
//                                                                            
//                                                                            

////////////////////////////////////////////////////////////
//
// Initialize the state of the simulation.
//

void
initializeSimulation ()
  {
  Grid.sDim                   =  200;
  Grid.tDim                   =  200;

  Grid.xBounds                =  SbVec2f(-1.0, 1.0);
  Grid.yBounds                =  SbVec2f(-1.0, 1.0);
  }







/////////////////////////////////////////////////////////////////////////////
//                                                  WW    WW                  
//                                                 W        W                 
//                              WW                WW        WW                
//                                                WW        WW                
// WWW WWW  WWW      WWWWWW     WW   WWW WWWWW    WW        WW                
//  WWW  WWW  WW    WW    WW   WWW    WWW    WW   WW        WW                
//  WW   WW   WW          WW    WW    WW     WW   WW        WW                
//  WW   WW   WW    WWWWWWWW    WW    WW     WW   WW        WW                
//  WW   WW   WW   WW     WW    WW    WW     WW   WW        WW                
//  WW   WW   WW   WW    WWW    WW    WW     WW   WW        WW                
// WWWW WWWW WWWW   WWWWW WWW  WWWW  WWWW   WWWW   W        W                 
//                                                  WW    WW                  
//                                                                            
//                                                                            


////////////////////////////////////////////////////////////
//
// main
//
// Initialize global variables.
// Create the graphics window.
// Create the scene graph.
// Give control to the Inventor main loop.

void
main(int argc, char **argv)
  {
  initializeSimulation ();

  SoXtExaminerViewer *viewer = 
    createAndLayoutMainWindow(argc, argv);


  SoSeparator *root = createScene();
  updateMesh();

  viewer->setSceneGraph(root);
  viewer->show();

  // Hand over control to Inventor.
  SoXt::mainLoop();
  }
